package tester;

import java.lang.annotation.Annotation;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import annotation.MeinTest;

public class Tester {

  //TODO: Refactor (zerlegen)
	public Map<String, String> testAusfuehren(String klassenname) {
		Class<?> clazz = null;
		if (klassenname == null) {
			throw new IllegalArgumentException(
					"Existenz der Klasse" + " null versucht zu pruefen");
		}
		try {
			clazz = Class.forName(klassenname);
		} catch (ClassNotFoundException ex) {
			throw new IllegalArgumentException(
					"Klasse " + klassenname + " nicht gefunden");
		}

		// Suche parameterlosen Konstruktor
		Constructor<?> konstruktor = null;
		try {
			konstruktor = clazz.getDeclaredConstructor(new Class[] {});
		} catch (NoSuchMethodException ex) {
			throw new IllegalArgumentException(
					"Klasse muss " + "parameterlosen Konstruktor haben");
		} catch (SecurityException ex) {
			throw new IllegalArgumentException(
					"kein ausfuehrbarer " + "parameterloser Konstruktor gefunden");
		}

		// berechne mit Test annotierter Methoden
		List<Method> auszufuehren = new ArrayList<>();

		for (Method methode : clazz.getDeclaredMethods()) {
			methode.setAccessible(true);
			for (Annotation anno : methode.getAnnotations()) {
				if (anno.annotationType() == MeinTest.class) {
					if (!methode.getReturnType().toString().equals("void")) {
						System.out.println("Methode " + methode.getName() 
						        + " ist kein Test, da Return-Typ nicht void");
					} else {
						if (methode.getParameterCount() != 0) {
							System.out.println("Methode " + methode.getName() 
									+ " ist kein Test, da Parameterliste nicht leer");
						} else {
							auszufuehren.add(methode);
						}
					}
				}
			}
		}
		if (auszufuehren.isEmpty()) {
			System.out.println("keinen Test gefunden");
			return null;
		}

		konstruktor.setAccessible(true);
		Object objekt = null;
		try {
			objekt = konstruktor.newInstance(new Object[] {});
		} catch (Exception ex) {
			throw new IllegalArgumentException("unerwarteter Fehler: " + ex);
		}

		// fuehre Methoden aus und fange Exceptions
		// es wird aktuell parameterlose Methode genutzt, zum Ausfuehren wird
		// dem Methodenobjekt das Objekt und die Parameterliste
		// uebergeben
		Map<String, String> ergebnis = new HashMap<>();
		for (Method m : auszufuehren) {
			try {
				m.setAccessible(true);
				m.invoke(objekt, new Object[] {});
				ergebnis.put(m.getName(), "ok");
			} catch (InvocationTargetException e) {
				ergebnis.put(m.getName()
						, e.getCause().getClass().getSimpleName() 
						        + " : " + e.getCause().getMessage());
			} catch (Exception e) {
				ergebnis.put(m.getName(), 
						e.getClass().getSimpleName() + " : " 
				                + e.getCause().getMessage());
			}
		}

		return ergebnis;
	}

}
